#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

// tarefas:

// 1. ler arquivo de dados (.pat) [OK]
// 2. gerar .res com saidas desejadas e saidas reais [OK]
// 3. comparar com .res gerado pelo SNNS [OK]

// 4. implementar ajuste de pesos [OK]

// 5. implementar geracao de arquivo .net

double **calloc2Ddouble(int m,int n);

void leCABPAT(int* numPadroesTreina, char* nomeArq, int* numEntradas, int* numSaidas);
void lePAT(int numPadroesTreina, char* nomeArq, int numEntradas, int numSaidas, double** entradas, double** saidas);

/*

void geraSaidasRBFs(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, double** saidasReais, double** saidasRBF, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina);

void calcSaidasRede(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, double** saidasReais, double** saidasRBF, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina);

*/

int calcErroClass(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina);


int calcErroClassVal(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina);



void ajustaPesos(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina);


void ajustaPesosVal(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina);


/*

void ajustaPesos2(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, double** saidasReais, double** saidasRBF, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina);

*/

void geraNET(int numEntradas, int numEscondidos,int numSaidas, double* pesos, int* classe, double** centros, double* sigma, char* nomeArquivoRede, char* nomeArquivoSaida);

double SSE, SSEval, SSEvalmin;

int argc;
char *argv[];

int main(int argc, char *argv[]) {

  FILE* InFile;
  FILE* OutFile;
  int numEscondidos, numEntradas, numSaidas, numUnits, ciclos, i, j, k, numErros, numErrosVal, numErrosMin;
  char leitura[255],comando[255], temp[255], temp2[255], temp3[255], *pontAux, temp4[255], temp5[255], nomeArquivoRede[100], nomeArquivoSaida[100];
  double *sigma, *pesos, **centros, **entradas, **saidas, pesoTemp;
  int *classe, classeTemp, entradaTemp, rbf, numPadroesTreina, epocasMax;

  double *sigmaMIN, *pesosMIN, **centrosMIN;
  int *classeMIN;

  /*  
  if (argc != 4)
  {
      printf ("Utilizacao: optPesosRBFDDA nomeArquivoRede epocasMax nomeArquivoSaida");
      exit(1);
  }

  */


  if (argc != 4)
  {
      printf ("This program must be used like this: adjustWeightsRBFDDA inputNetwork maxEpochs outputNetwork \n ==> Parameter 1 is the name of the .net file generated by SNNS.\n ==> Parameter 2 is the maximum number of training epochs.\n ==> Parameter 3 is the name of the output network (network with weights adjusted via gradient-descent)");
      exit(1);
  }


  strcpy(nomeArquivoRede,argv[1]);                 

  epocasMax=atoi(argv[2]);
  
  strcpy(nomeArquivoSaida,argv[3]);      

  // soybean
  /*
  numPadroesTreina=513;
  numEscondidos=221;
  numEntradas=82;
  numSaidas=19;
  */

  // optdigits
  /*    
  numPadroesTreina=3823;
  numEscondidos=3697;
  numEntradas=64;
  numSaidas=10;
  */


  // pendigits
  /*
  numPadroesTreina=7494;
  numEscondidos=1427;
  numEntradas=16;
  numSaidas=10;
  */


  // letter
  /*
  numPadroesTreina=15000;
  numEscondidos=7789;
  numEntradas=16;
  numSaidas=26;
  */


  printf("\nTeste\n");

  leCABPAT(&numPadroesTreina, "treina.pat", &numEntradas, &numSaidas);

  entradas=calloc2Ddouble(numPadroesTreina, numEntradas);
  saidas=calloc2Ddouble(numPadroesTreina, numSaidas);


  lePAT(numPadroesTreina, "treina.pat", numEntradas, numSaidas, entradas, saidas);

   printf("\nTeste2\n");

   //   printf("TESTE, entradas[0][0]=%f\n ",entradas[0][0]);



  if ((InFile = fopen(nomeArquivoRede, "r")) == NULL) {
      printf("\nERRO: arquivo inexistente\n");
      exit(-1);
   }


  // le 5 linhas iniciais e descarta
  for(i=0;i<5;i++) {
         fgets(leitura,255,InFile);
  }
	 
  fgets(leitura,255,InFile);
  numUnits=atoi(&leitura[15]);       


  numEscondidos=numUnits-numEntradas-numSaidas;

      printf("\nnumUnits=%i,numEnt=%i,numS=%i,numEsc=%i\n", numUnits,numEscondidos,numEntradas,numSaidas);

  // alocacao dinamica de vetores e matrizes

  sigma=calloc(numEscondidos, sizeof(double));
  pesos=calloc(numEscondidos, sizeof(double));  
  classe=calloc(numEscondidos, sizeof(int));

  centros=calloc2Ddouble(numEscondidos, numEntradas);



    printf("\nTeste 33\n");

  sigmaMIN=calloc(numEscondidos, sizeof(double));
  pesosMIN=calloc(numEscondidos, sizeof(double));
  classeMIN=calloc(numEscondidos, sizeof(int));
  centrosMIN=calloc2Ddouble(numEscondidos, numEntradas);

  



  // as duas matrizes abaixo nao precisam ser armazenadas,
  // podem ser calculadas a cada iteracao
  
  /*
  saidasReais=calloc2Ddouble(numPadroesTreina, numSaidas);
  saidasRBF=calloc2Ddouble(numPadroesTreina, numEscondidos);
  */

  // printf("\nTeste\n");



  //  printf("\nTeste2\n");



    
  // le 21 linhas e descarta
  for(i=0;i<21;i++) {
         fgets(leitura,255,InFile);
  }  
	 
  // a partir de agora, le numUnits linhas e copia o sigma das RBF (unidades escondidas) - h

  j=0;
  for(i=0;i<numUnits;i++) {
       fgets(leitura,255,InFile);
       strtok(leitura, "|");
       strtok(NULL, "|");
       strtok(NULL, "|");	       

       strtok(NULL, "|");
       strcpy(temp, strtok(NULL, "|"));

       strcpy(temp2, strtok(NULL, "|"));	     

       if(strstr(temp2, "h")!=NULL)
	 {
	   sigma[j]=atof(temp);
	     ++j; 

	 } 
	       
	       
       //	       printf( "temp = %s, double=%f\n", temp, atof(temp));
	       

  }
       

     // le mais sete linhas e descarta antes de chegar na secao de definicao de conexoes

    for(i=0;i<7;i++) {

	 fgets(leitura,255,InFile);

   }
     

    // leitura das conexoes (da camada escondida para a saida)

  classeTemp=0;
  while(classeTemp<(numSaidas+numEntradas+1)  )
  {

    fgets(leitura,255,InFile);     

    strcpy(temp4,leitura);
    strcpy(temp5,leitura);
    strcpy(temp3, strtok(temp4, "|"));
   
    /*
    printf("atoi(temp3)= %i\n", atoi(temp3));

   if((atoi(temp3))==(numSaidas+numEntradas+1)) break;
    */

    /*
    printf("classeTemp= %i\n", classeTemp);
    printf("leitura= %s\n", leitura);
    */

    if(strstr(leitura, "|")!=NULL) {
      
      strcpy(temp,strtok(leitura, "|"));
      classeTemp=atoi(temp);	     

      /*      
      printf("leitura: %s\n", leitura);
      printf("temp=%s, classeTemp=%i, numSaidas+numEntradas+1=%i\n", temp, classeTemp, numSaidas+numEntradas+1);
      */

      if(classeTemp==(numSaidas+numEntradas+1)) break;
          

      strtok(NULL, "|");
      strcpy(temp,strtok(NULL, "|"));

      //     printf("   Novo temp=%s\n", temp);

     if(strstr(temp, ",")!=NULL) {

       // ha mais de uma rbf associada a esta saida
       //       printf("ha MAIS de uma rbf associada a esta saida\n");

       strcpy(temp2,strtok(temp, ","));
       //       printf("temp2=%s\n", temp2);
     
       while(strstr(temp2, ":")!=NULL) {      

	 //	 printf("temp2=%s\n", temp2);
	 //	 printf("   peso=%f\n",atof(strstr(temp2, ":")+1));

	 strcpy(temp3, strstr(temp2, ":")+1);
         pesoTemp=atof(temp3);
	 
	 temp2[strlen(temp2)-strlen(temp3)]='\0';

	 rbf=atoi(temp2);
	 rbf=rbf-(numEntradas+numSaidas+1);
	 pesos[rbf]=pesoTemp;
	 classe[rbf]=classeTemp-numEntradas-1;

	 //         printf("peso[%i]=%f, classe[%i]=%i\n",rbf,pesos[rbf],rbf,classe[rbf]);

	 //	 printf(" ----> Ultimo valor temp2 (antes do strtok)=%s\n",temp2);

	 pontAux=strtok(NULL, ",");

	 if(pontAux!=NULL)
	   strcpy(temp2,pontAux);       
	 else
	   break;

	 //	 printf(" ----> Ultimo valor temp2=%s, temp=%s\n",temp2, temp);

       } 
     }
     else {
       // ha apenas uma rbf associada a esta saida

       //       printf("ha apenas uma rbf associada a esta saida\n");
       strcpy(temp2,strtok(temp, ":"));       
       //       printf("temp2 (1)=%s\n", temp2);

       rbf=atoi(temp2);

       rbf=rbf-(numEntradas+numSaidas+1);
       
       strcpy(temp2,strtok(NULL, ":"));       
       //       printf("temp2 (2)=%s\n", temp2);


       pesos[rbf]=atof(temp2);
       classe[rbf]=classeTemp-numEntradas-1;

       //       printf("peso[%i]=%f, classe[%i]=%i\n",rbf,pesos[rbf],rbf,classe[rbf]);
       
     }
     

    }
    else {
      // a linha eh uma continuacao da unidade anterior

      strcpy(temp,leitura);

     if(strstr(temp, ",")!=NULL) {

       // ha mais de uma rbf associada a esta saida
       //       printf("ha MAIS de uma rbf associada a esta saida\n");

       strcpy(temp2,strtok(temp, ","));
       //       printf("temp2=%s\n", temp2);
     
       while(strstr(temp2, ":")!=NULL) {      

	 //	 printf("temp2=%s\n", temp2);
	 //	 printf("   peso=%f\n",atof(strstr(temp2, ":")+1));

	 strcpy(temp3, strstr(temp2, ":")+1);
         pesoTemp=atof(temp3);
	 
	 temp2[strlen(temp2)-strlen(temp3)]='\0';

	 rbf=atoi(temp2);
	 rbf=rbf-(numEntradas+numSaidas+1);
	 pesos[rbf]=pesoTemp;
	 classe[rbf]=classeTemp-numEntradas-1;

	 //         printf("peso[%i]=%f, classe[%i]=%i\n",rbf,pesos[rbf],rbf,classe[rbf]);

	 //	 printf(" ----> Ultimo valor temp2 (antes do strtok)=%s\n",temp2);

	 pontAux=strtok(NULL, ",");

	 if(pontAux!=NULL)
	   strcpy(temp2,pontAux);       
	 else
	   break;

	 //	 printf(" ----> Ultimo valor temp2=%s, temp=%s\n",temp2, temp);

       } 
     }
     else {
       // ha apenas uma rbf associada a esta saida

       //       printf("ha apenas uma rbf associada a esta saida\n");
       strcpy(temp2,strtok(temp, ":"));       
       //       printf("temp2 (1)=%s\n", temp2);

       rbf=atoi(temp2);

       rbf=rbf-(numEntradas+numSaidas+1);
       
       strcpy(temp2,strtok(NULL, ":"));       
       //       printf("temp2 (2)=%s\n", temp2);


       pesos[rbf]=atof(temp2);
       classe[rbf]=classeTemp-numEntradas-1;

       //       printf("peso[%i]=%f, classe[%i]=%i\n",rbf,pesos[rbf],rbf,classe[rbf]);
       
     }
    }

  }


  strcpy(leitura,temp5);

  //    printf("concluida leitura dos pesos. temp5=%s\n",temp5);


    //    exit(-1);

  // concluida leitura dos valores dos pesos das conexoes das
  // RBFs da camada escondida as unidades de saida

  // iniciar leitura dos centros das RBFs

// lembrar que uma linha ja foi lida antes na leitura das conexoes


  rbf=0;
  while(rbf<numEscondidos)
  {

  
    if(strstr(leitura, "-----------------")!=NULL) break;

    if(strstr(leitura, "|")!=NULL) {
      
      strcpy(temp,strtok(leitura, "|"));
      rbf=atoi(temp)-(numEntradas+numSaidas+1);	     

      /*      
      printf("leitura: %s\n", leitura);
      printf("temp=%s, rbf=%i\n", temp, rbf);
      */

      strtok(NULL, "|");
      strcpy(temp,strtok(NULL, "|"));

      //     printf("   Novo temp=%s\n", temp);

     if(strstr(temp, ",")!=NULL) {

       // ha mais de uma rbf associada a esta saida
       //       printf("ha MAIS de uma rbf associada a esta saida\n");

       strcpy(temp2,strtok(temp, ","));
       //       printf("temp2=%s\n", temp2);
     
       while(strstr(temp2, ":")!=NULL) {      

	 //	 printf("temp2=%s\n", temp2);
	 //	 printf("   peso=%f\n",atof(strstr(temp2, ":")+1));

	 strcpy(temp3, strstr(temp2, ":")+1);
         pesoTemp=atof(temp3);
	 
	 temp2[strlen(temp2)-strlen(temp3)]='\0';


	 centros[rbf][atoi(temp2)-1]=pesoTemp;

	 //         printf("centros[%i][%i]=%f\n",rbf,atoi(temp2)-1,centros[rbf][atoi(temp2)-1]);

	 //	 printf(" ----> Ultimo valor temp2 (antes do strtok)=%s\n",temp2);

	 pontAux=strtok(NULL, ",");

	 if(pontAux!=NULL)
	   strcpy(temp2,pontAux);       
	 else
	   break;

	 //	 printf(" ----> Ultimo valor temp2=%s, temp=%s\n",temp2, temp);

       } 
     }
     else {
       // ha apenas uma rbf associada a esta saida

       //       printf("ha apenas uma rbf associada a esta saida\n");
       strcpy(temp2,strtok(temp, ":"));       
       //       printf("temp2 (1)=%s\n", temp2);

       entradaTemp=atoi(temp2)-1;

       
       strcpy(temp2,strtok(NULL, ":"));       
       //       printf("temp2 (2)=%s\n", temp2);


       centros[rbf][entradaTemp]=atof(temp2);

       //       printf("centros[%i][%i]=%f\n",rbf,entradaTemp,centros[rbf][entradaTemp]);

       
     }
     

    }
    else {
      // a linha eh uma continuacao da unidade anterior

      strcpy(temp,leitura);

     if(strstr(temp, ",")!=NULL) {

       // ha mais de uma rbf associada a esta saida
       //       printf("ha MAIS de uma rbf associada a esta saida\n");

       strcpy(temp2,strtok(temp, ","));
       //       printf("temp2=%s\n", temp2);
     
       while(strstr(temp2, ":")!=NULL) {      

	 //	 printf("temp2=%s\n", temp2);
	 //	 printf("   peso=%f\n",atof(strstr(temp2, ":")+1));

	 strcpy(temp3, strstr(temp2, ":")+1);
         pesoTemp=atof(temp3);
	 
	 temp2[strlen(temp2)-strlen(temp3)]='\0';

	 centros[rbf][atoi(temp2)-1]=pesoTemp;

	 //         printf("centros[%i][%i]=%f\n",rbf,atoi(temp2)-1,centros[rbf][atoi(temp2)-1]);

	 //	 printf(" ----> Ultimo valor temp2 (antes do strtok)=%s\n",temp2);

	 pontAux=strtok(NULL, ",");

	 if(pontAux!=NULL)
	   strcpy(temp2,pontAux);       
	 else
	   break;

	 //	 printf(" ----> Ultimo valor temp2=%s, temp=%s\n",temp2, temp);

       } 
     }
     else {
      
       // ha apenas uma rbf associada a esta saida

       //       printf("ha apenas uma rbf associada a esta saida\n");
       strcpy(temp2,strtok(temp, ":"));       
       //       printf("temp2 (1)=%s\n", temp2);

       entradaTemp=atoi(temp2)-1;

       
       strcpy(temp2,strtok(NULL, ":"));       
       //       printf("temp2 (2)=%s\n", temp2);


       centros[rbf][entradaTemp]=atof(temp2);

       //       printf("centros[%i][%i]=%f\n",rbf,entradaTemp,centros[rbf][entradaTemp]);

     }
    }

    fgets(leitura,255,InFile);  

  }


  // concluida leitura dos centros das RBFs e do arquivo .net

    printf( "no. of units = %i\n", numUnits);

  /*
  for(i=0;i<numEscondidos;i++) {
    printf( "sigma[%i] = %f\n", i,sigma[i]);

  }
  */

      printf("Teste3.1\n");

  fclose(InFile);

      printf("Teste3.2\n");

    /*
  geraSaidasRBFs(entradas, saidas, centros, sigma, pesos, classe, saidasReais, saidasRBF, numEntradas, numEscondidos, numSaidas, numPadroesTreina);
    */
  //      printf("Teste3.5\n");


	  printf("TESTE\n ");
	  //

  numErros=calcErroClass(entradas, saidas, centros, sigma, pesos, classe, numEntradas, numEscondidos, numSaidas, numPadroesTreina);


  //    printf("\nTeste\n");

  numErrosVal=calcErroClassVal(entradas, saidas, centros, sigma, pesos, classe, numEntradas, numEscondidos, numSaidas, numPadroesTreina);


       printf("epocasMax=%i\n",epocasMax);

  //  for(i=0;i<300;i++) {
    
  i=1;
  numErrosMin=numPadroesTreina;

  SSEvalmin=SSEval;
  do { 
    ajustaPesosVal(entradas, saidas, centros, sigma, pesos, classe, numEntradas, numEscondidos, numSaidas, numPadroesTreina);

    printf("Epoca= %i ",i);
    numErros=calcErroClass(entradas, saidas, centros, sigma, pesos, classe, numEntradas, numEscondidos, numSaidas, numPadroesTreina);
    numErrosVal=calcErroClassVal(entradas, saidas, centros, sigma, pesos, classe, numEntradas, numEscondidos, numSaidas, numPadroesTreina);

    /*

    if(numErros<numErrosMin) {
    numErrosMin=numErros;  */


    printf("SSEval=%f, SSEvalmin=%f\n",SSEval,SSEvalmin);    


    // parando no primeiro aumento do erro de validacao

    
    if(SSEval<SSEvalmin) {
      
      SSEvalmin=SSEval;

      printf("NO IF: SSEval=%f, SSEvalmin=%f\n",SSEval,SSEvalmin); 

      // salva a rede que deu erro minimo
      
      for(j=0;j<numEscondidos;j++) {
	sigmaMIN[j]=sigma[j];
	pesosMIN[j]=pesos[j];
	classeMIN[j]=classe[j];
	for(k=0;k<numEntradas;k++) centrosMIN[j][k]=centros[j][k];
      }
      

    }
    else {


 
      printf("NO BREAK: SSEval=%f, SSEvalmin=%f\n",SSEval,SSEvalmin);    


      break;
      }  



    // parando pelo criterio GL5
    /*
    
    if(SSEval<SSEvalmin) {
      
      SSEvalmin=SSEval;

      printf("NO IF: SSEval=%f, SSEvalmin=%f\n",SSEval,SSEvalmin); 

      // salva a rede que deu erro minimo
      
      for(j=0;j<numEscondidos;j++) {
	sigmaMIN[j]=sigma[j];
	pesosMIN[j]=pesos[j];
	classeMIN[j]=classe[j];
	for(k=0;k<numEntradas;k++) centrosMIN[j][k]=centros[j][k];
      }
      

    }
    else if( ( 100.0*( (SSEval/SSEvalmin)-1.0 ) ) > 5.0  ) {


 
      printf("NO BREAK: SSEval=%f, SSEvalmin=%f\n",SSEval,SSEvalmin);    


      break;
      }  
    else {

     printf("Erro val. maior que o anterior, mas nao atingiu GL5: SSEval=%f, SSEvalmin=%f, gl=%f\n",SSEval,SSEvalmin,( 100.0*( (SSEval/SSEvalmin)-1.0 ) )  );    


    }

*/

    ++i;

     printf("i=%i\n",i);    

    
 
 
    } while( (i<=epocasMax) );  


  // grava arquivo .net da rede otimizada
  
  for(j=0;j<numEscondidos;j++) {
    sigma[j]=sigmaMIN[j];
    pesos[j]=pesosMIN[j];
    classe[j]=classeMIN[j];
    for(k=0;k<numEntradas;k++) centros[j][k]=centrosMIN[j][k];
  }
  
   geraNET(numEntradas, numEscondidos, numSaidas, pesos, classe, centros, sigma, nomeArquivoRede, nomeArquivoSaida);
    
}
/*
void  geraSaidasRBFs(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, double** saidasReais, double** saidasRBF, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina) {

  int i,j,k;
  double euclid;

  printf("gera \n");

  for(i=0;i<numPadroesTreina;i++)
    //  for(i=0;i<1;i++)
    {
  // calcula saidas das RBFs

      printf("i=%i \n",i);

      for(j=0;j<numEscondidos;j++) {
	
	euclid=0.0;
	for(k=0;k<numEntradas;k++) {

	  euclid+=(entradas[i][k]-centros[j][k])*(entradas[i][k]-centros[j][k]);

	  //	  printf("centros[%i][%i]=%f\n",j,k,centros[j][k]);
	}
   
	// na verdade, eu carreguei no vetor sigma o valor de bias (lido de .net).
	// sigma^2 eh 1/bias, de acordo com o codigo em learn_f.c (SNNS)

	saidasRBF[i][j]=exp( - (euclid) /  (1/sigma[j]) );
	
      }

    }

}

*/

/*

void  calcSaidasRede(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, double** saidasReais, double** saidasRBF, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina) {

  int i,j;

  for(i=0;i<numPadroesTreina;i++)
    {

  // calcula saidas da rede

      // zera vetor de saidas da rede

      for(j=0;j<numSaidas;j++) saidasReais[i][j]=0.0;

      // varre o vetor classe, indexado por RBFs            

 
      for(j=0;j<numEscondidos;j++) {
	
	//	if(classe[j]==15) printf("classe[%i]=%i, peso[%i]=%f\n",j,classe[j],j,pesos[j]);
	saidasReais[i][classe[j]]+=(saidasRBF[i][j]*pesos[j]);
	       

      }
    }
}

*/

int  calcErroClass(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina) {

  int i,j, k,classeRede, classeDesejada, numErros=0, numRed;
  double max, max2, *saidasRBF, *saidasReais, euclid;
  
  //  printf("numEscondidos=%i, numSaidas=%i \n",numEscondidos,numSaidas);

  saidasRBF=calloc(numEscondidos, sizeof(double));
  saidasReais=calloc(numSaidas, sizeof(double));

  SSE=0.0;


  numRed=numPadroesTreina-(int)(0.25*numPadroesTreina);

  //      printf("\nnumRed=%i\n",numRed);


  for(i=0;i<numRed;i++)
    {

  // calcula saidas das RBFs para o padrao atual (i)

      //               printf("i=%i \n",i);

      for(j=0;j<numEscondidos;j++) {

        //         printf("j=%i \n",j);
	
	euclid=0.0;

	for(k=0;k<numEntradas;k++) {

          //       printf("k=%i \n",k);



	  euclid+=(entradas[i][k]-centros[j][k])*(entradas[i][k]-centros[j][k]);

	  //	  printf("centros[%i][%i]=%f\n",j,k,centros[j][k]);
	}
   

	// na verdade, eu carreguei no vetor sigma o valor de bias (lido de .net).
	// sigma^2 eh 1/bias, de acordo com o codigo em learn_f.c (SNNS)
	saidasRBF[j]=exp( - (euclid) /  (1/sigma[j]) );
	
      }
   
  // calcula saidas da rede

      // zera vetor de saidas da rede

      for(j=0;j<numSaidas;j++) saidasReais[j]=0.0;

      // varre o vetor classe, indexado por RBFs            

      for(j=0;j<numEscondidos;j++) {
	
	//	if(classe[j]==15) printf("classe[%i]=%i, peso[%i]=%f\n",j,classe[j],j,pesos[j]);
	saidasReais[classe[j]]+=(saidasRBF[j]*pesos[j]);	       
      }

     max=0.0;
     max2=0.0;
     for(j=0;j<numSaidas;j++) {
       //       printf("saidasR[%i]=%f\n",j,saidasR[j]);

       SSE+=( (saidasReais[j]-saidas[i][j])*(saidasReais[j]-saidas[i][j]) );

       if(saidasReais[j]>max) {
	 max=saidasReais[j];
	 classeRede=j;
       }

      if(saidas[i][j]>max2) {
	 max2=saidas[i][j];
	 classeDesejada=j;
       }
 
   }

     if(classeRede!=classeDesejada) ++numErros;

     /*     
     if(classeRede!=classeDesejada) {
       ++numErros;
       printf("padrao %i classificado erroneamente\n",i);
       printf("   saidaMaior=%f, saidaCorretaDesejada=%f\n",saidasReais[i][classeRede],saidasReais[i][classeDesejada]);

       for(j=0;j<numEscondidos;j++) {
	
	if(classe[j]==classeRede) printf("   -> Saida RBF associada a classe rede:%f \n",saidasRBF[i][j]);
	if(classe[j]==classeDesejada) printf("   -> Saida RBF associada a classe desejada:%f \n",saidasRBF[i][j]);	       

      }

      } */
     
    }

  printf("Num. erros de treino (red)=%i, percentual=%6.5f, SSE treino=%6.5f\n", numErros, 100.0*((double)numErros/(double)numRed), SSE);

  free(saidasRBF);
  free(saidasReais);

  return numErros;



}


int  calcErroClassVal(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina) {

  int i,j, k,classeRede, classeDesejada, numErros=0, numVal,numRed;
  double max, max2, *saidasRBF, *saidasReais, euclid;
  
  //  printf("numEscondidos=%i, numSaidas=%i \n",numEscondidos,numSaidas);

  saidasRBF=calloc(numEscondidos, sizeof(double));
  saidasReais=calloc(numSaidas, sizeof(double));

  SSEval=0.0;


  numRed=numPadroesTreina-(int)(0.25*numPadroesTreina);

  numVal=(int)(0.25*numPadroesTreina);

  //  printf("numEscondidos=%i, numSaidas=%i, numRed=%i, numVal=%i \n",numEscondidos,numSaidas, numRed, numVal);




  for(i=numRed;i<numPadroesTreina;i++)
    {

  // calcula saidas das RBFs para o padrao atual (i)

      //            printf("i=%i \n",i);

      for(j=0;j<numEscondidos;j++) {
	
	euclid=0.0;

	for(k=0;k<numEntradas;k++) {

	  euclid+=(entradas[i][k]-centros[j][k])*(entradas[i][k]-centros[j][k]);

	  //	  printf("centros[%i][%i]=%f\n",j,k,centros[j][k]);
	}
   

	// na verdade, eu carreguei no vetor sigma o valor de bias (lido de .net).
	// sigma^2 eh 1/bias, de acordo com o codigo em learn_f.c (SNNS)
	saidasRBF[j]=exp( - (euclid) /  (1/sigma[j]) );
	
      }
   
  // calcula saidas da rede

      // zera vetor de saidas da rede

      for(j=0;j<numSaidas;j++) saidasReais[j]=0.0;

      // varre o vetor classe, indexado por RBFs            

      for(j=0;j<numEscondidos;j++) {
	
	//	if(classe[j]==15) printf("classe[%i]=%i, peso[%i]=%f\n",j,classe[j],j,pesos[j]);
	saidasReais[classe[j]]+=(saidasRBF[j]*pesos[j]);	       
      }

     max=0.0;
     max2=0.0;
     for(j=0;j<numSaidas;j++) {
       //       printf("saidasR[%i]=%f\n",j,saidasR[j]);

       SSEval+=( (saidasReais[j]-saidas[i][j])*(saidasReais[j]-saidas[i][j]) );

       if(saidasReais[j]>max) {
	 max=saidasReais[j];
	 classeRede=j;
       }

      if(saidas[i][j]>max2) {
	 max2=saidas[i][j];
	 classeDesejada=j;
       }
 
   }

     if(classeRede!=classeDesejada) ++numErros;

     /*     
     if(classeRede!=classeDesejada) {
       ++numErros;
       printf("padrao %i classificado erroneamente\n",i);
       printf("   saidaMaior=%f, saidaCorretaDesejada=%f\n",saidasReais[i][classeRede],saidasReais[i][classeDesejada]);

       for(j=0;j<numEscondidos;j++) {
	
	if(classe[j]==classeRede) printf("   -> Saida RBF associada a classe rede:%f \n",saidasRBF[i][j]);
	if(classe[j]==classeDesejada) printf("   -> Saida RBF associada a classe desejada:%f \n",saidasRBF[i][j]);	       

      }

      } */
     
    }

  printf("Num. erros de val.=%i, percentual=%6.5f, SSE val=%6.5f\n", numErros, 100.0*((double)numErros/(double)numVal), SSEval);

  free(saidasRBF);
  free(saidasReais);

  return numErros;



}


// ajuste de pesos (metodo do gradiente descendente)

void  ajustaPesos(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina) {

  int i,j,m,k;
  double txAprend=0.01,erro, *saidasRBF, *saidasReais, euclid;

  saidasRBF=calloc(numEscondidos, sizeof(double));
  saidasReais=calloc(numSaidas, sizeof(double));

  for(i=0;i<numPadroesTreina;i++) {

    for(j=0;j<numSaidas;j++) {
     
      // calcula saida atual para calcular o erro 
      // para este padrao
      
  // calcula saidas das RBFs para o padrao atual (i)

      //            printf("i=%i \n",i);

      for(m=0;m<numEscondidos;m++) {

	// se RBF estiver conectada a saida j
	
	if(classe[m]==j) {
	  euclid=0.0;
	  for(k=0;k<numEntradas;k++) {
	    euclid+=(entradas[i][k]-centros[m][k])*(entradas[i][k]-centros[m][k]);
	  }
	
   
	  // na verdade, eu carreguei no vetor sigma o valor de bias (lido de .net).
	  // sigma^2 eh 1/bias, de acordo com o codigo em learn_f.c (SNNS)
	  saidasRBF[m]=exp( - (euclid) /  (1/sigma[m]) );
	}
	
      }


      // zera saida
      saidasReais[j]=0.0;

      // varre o vetor classe, indexado por RBFs            
      for(m=0;m<numEscondidos;m++) {
	if(classe[m]==j)	
	  saidasReais[classe[m]]+=(saidasRBF[m]*pesos[m]);	       
	  }
 
      // calcula o erro cometido para a saida j
      erro=(saidas[i][j]-saidasReais[j]);
      

      // ajusta os pesos conectados a saida j
      for(m=0;m<numEscondidos;m++) {
	
	if(classe[m]==j)
	  pesos[m]=pesos[m]+(txAprend*erro*saidasRBF[m]);

	// testando: ajusta o sigma da rbf

	// se fizer a linha abaixo, tem que alterar geraNet para 
	// gravar novos valores de sigma!

	//	sigma[m]=1.0/( (1.0/sigma[m]) + (txAprend*erro) );

      }

    }

  }

  free(saidasRBF);
  free(saidasReais);


}


void  ajustaPesosVal(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina) {

  int i,j,m,k,numRed;
  double txAprend=0.1,erro, *saidasRBF, *saidasReais, euclid;

  saidasRBF=calloc(numEscondidos, sizeof(double));
  saidasReais=calloc(numSaidas, sizeof(double));


  numRed=numPadroesTreina-(int)(0.25*numPadroesTreina);

  for(i=0;i<numRed;i++) {

    for(j=0;j<numSaidas;j++) {
     
      // calcula saida atual para calcular o erro 
      // para este padrao
      
  // calcula saidas das RBFs para o padrao atual (i)

      //            printf("i=%i \n",i);

      for(m=0;m<numEscondidos;m++) {

	// se RBF estiver conectada a saida j
	
	if(classe[m]==j) {
	  euclid=0.0;
	  for(k=0;k<numEntradas;k++) {
	    euclid+=(entradas[i][k]-centros[m][k])*(entradas[i][k]-centros[m][k]);
	  }
	
   
	  // na verdade, eu carreguei no vetor sigma o valor de bias (lido de .net).
	  // sigma^2 eh 1/bias, de acordo com o codigo em learn_f.c (SNNS)
	  saidasRBF[m]=exp( - (euclid) /  (1/sigma[m]) );
	}
	
      }


      // zera saida
      saidasReais[j]=0.0;

      // varre o vetor classe, indexado por RBFs            
      for(m=0;m<numEscondidos;m++) {
	if(classe[m]==j)	
	  saidasReais[classe[m]]+=(saidasRBF[m]*pesos[m]);	       
	  }
 
      // calcula o erro cometido para a saida j
      erro=(saidas[i][j]-saidasReais[j]);
      

      // ajusta os pesos conectados a saida j
      for(m=0;m<numEscondidos;m++) {
	
	if(classe[m]==j)
	  pesos[m]=pesos[m]+(txAprend*erro*saidasRBF[m]);

	// testando: ajusta o sigma da rbf

	// se fizer a linha abaixo, tem que alterar geraNet para 
	// gravar novos valores de sigma!

	//	sigma[m]=1.0/( (1.0/sigma[m]) + (txAprend*erro) );

      }

    }

  }

  free(saidasRBF);
  free(saidasReais);


}



// ajuste de pesos (segundo metodo)
/*
void  ajustaPesos2(double** entradas, double** saidas, double** centros, double* sigma, double* pesos, int* classe, double** saidasReais, double** saidasRBF, int numEntradas, int numEscondidos,int numSaidas, int numPadroesTreina) {

  int i,j,m,classeRede,classeDesejada;
  double txAprend=0.00001,erro, max=0.0, max2=0.0, fatorCorrecao;

  for(i=0;i<numPadroesTreina;i++) {

    // calcula classes fornecida e desejada do padrao

     max=0.0;
     max2=0.0;
     for(j=0;j<numSaidas;j++) {
       //       printf("saidasR[%i]=%f\n",j,saidasR[j]);

       if(saidasReais[i][j]>max) {
	 max=saidasReais[i][j];
	 classeRede=j;
       }

      if(saidas[i][j]>max2) {
	 max2=saidas[i][j];
	 classeDesejada=j;
       }
 
     }

     if(classeRede!=classeDesejada) {

       // padrao classificado de maneira incorreta, segundo WTA

 

       fatorCorrecao=(saidasReais[i][classeRede]/saidasReais[i][classeDesejada]);

       //    printf("padrao %i classificado de maneira incorreta. fatorCorrecao=%f\n",i,fatorCorrecao);


       for(m=0;m<numEscondidos;m++) {
	
	if(classe[m]==classeDesejada)
	  pesos[m]=pesos[m]*fatorCorrecao*0.001;
      }
       

    }
    

  }

}


*/


// Le cabecalho do arquivo com padroes de treinamento
void leCABPAT(int* numPadroesTreina, char* nomeArq, int* numEntradas, int* numSaidas) {

  FILE *InFile;
  int i,j,k;
  char leitura[255];

  if ((InFile = fopen(nomeArq, "r")) == NULL) {
      printf("\nERRO: arquivo %s inexistente\n", nomeArq);
      exit(-1);
   }

  // le 4 linhas iniciais (cabecalho) e descarta
  for(i=0;i<4;i++) {
         fgets(leitura,255,InFile);
  }


  fgets(leitura,255,InFile);
  *numPadroesTreina=atoi(&leitura[17]);

  fgets(leitura,255,InFile);
  *numEntradas=atoi(&leitura[20]);

  fgets(leitura,255,InFile);
  *numSaidas=atoi(&leitura[21]);

  printf("\nnumPadroesTreina=%i, numEntradas=%i, numSaidas=%i\n", *numPadroesTreina,*numEntradas,*numSaidas);
 
  fclose(InFile);

}





// Le arquivo com padroes de treinamento
void lePAT(int numPadroesTreina, char* nomeArq, int numEntradas, int numSaidas, double** entradas, double** saidas) {

  FILE *InFile;
  int i,j,k;
  char leitura[255];

  if ((InFile = fopen(nomeArq, "r")) == NULL) {
      printf("\nERRO: arquivo %s inexistente\n", nomeArq);
      exit(-1);
   }

  // le 8 linhas iniciais (cabecalho) e descarta
  for(i=0;i<8;i++) {
         fgets(leitura,255,InFile);
  }


  j=0;
  while(!feof(InFile)) {

    fgets(leitura,255,InFile);
    
    //        printf("j=%i, leitura=%s\n", j, leitura);
    
    // carrega entradas referentes ao padrao j

    strtok(leitura, " ");
    entradas[j][0]=atof(leitura);
    //    printf("entradas[%i][0]=%f\n", j,entradas[j][0]);

    for(k=1;k<numEntradas;k++) {      
      entradas[j][k]=atof(strtok(NULL, " "));
      //      printf("entradas[%i][%i]=%f\n", j,k,entradas[j][k]);
    }

    // carrega saidas referentes ao padrao j

    saidas[j][0]=atof(strtok(NULL, " "));
    //    printf("saidas[%i][0]=%f\n", j,saidas[j][0]);

    for(k=1;k<numSaidas;k++) {      
      saidas[j][k]=atof(strtok(NULL, " "));
   //      printf("saidas[%i][%i]=%f\n", j,k,saidas[j][k]);
    }

    ++j;

    if(j>=numPadroesTreina)
        break;
	
  }
 
  fclose(InFile);

}


void geraNET(int numEntradas, int numEscondidos,int numSaidas, double* pesos, int* classe, double** centros, double* sigma, char* nomeArquivoRede, char* nomeArquivoSaida) {

  FILE *InFile, *OutFile;
  int i,j,k,flag=0;
  char leitura[255], temp[255], temp2[255];

  if ((InFile = fopen(nomeArquivoRede, "r")) == NULL) {
      printf("\nERRO: arquivo inexistente\n");
      exit(-1);
   }

  if ((OutFile = fopen(nomeArquivoSaida, "w")) == NULL) {
      printf("\nERRO: nao consigo criar o arquivo\n");
      exit(-1);
   }


  // nova parte da funcao para atualizar valores de sigma

  do {

   fgets(leitura,255,InFile);
   fputs(leitura , OutFile);

  } while(strstr(leitura, "unit definition section")==NULL);


  // le e escreve no arq. de saida mais 3+numEntradas+numSaidas linhas  
  for(i=0;i<(3+numEntradas+numSaidas);i++) {
   fgets(leitura,255,InFile);
   fputs(leitura , OutFile);
  }

  // escreve novos sigmas no arquivo 
  for(i=0;i<numEscondidos;i++) {

   fgets(leitura,255,InFile);

   fprintf(OutFile," %i " , i+numEntradas+numSaidas+1);
   fprintf(OutFile, "|          |          |  0.01573 |");
   fprintf(OutFile," %f " , sigma[i]);   
   fprintf(OutFile, "| h  | 0,0, 0 | Act_RBF_Gaussian |          |\n");

 
  }


  do {

   fgets(leitura,255,InFile);
   fputs(leitura , OutFile);

  } while(strstr(leitura, "connection definition section")==NULL);

  // le e escreve no arq. de saida mais 3 linhas  
  for(i=0;i<3;i++) {
   fgets(leitura,255,InFile);
   fputs(leitura , OutFile);
  }

  // escreve os valores atuais dos pesos no arquivo de saida

  for(i=0;i<numSaidas;i++) {

    fprintf(OutFile, "    %i |      | ",i+numEntradas+1); 
    flag=0;
    for(j=0;j<numEscondidos;j++) {

      if(classe[j]==i) {
	if(flag==0) {
	  fprintf(OutFile, "%i: %6.5f",j+(numEntradas+numSaidas+1),pesos[j]);
	  flag=1;
	}
	else
	  fprintf(OutFile, ", %i: %6.5f",j+(numEntradas+numSaidas+1),pesos[j]);
	  
      }
    }
    fprintf(OutFile, "\n");

  }

  // escreve valores dos centros das rbfs no arquivo .net de saida
  /*
  for(i=0;i<numEscondidos;i++) {

    fprintf(OutFile, "    %i |      | ",i+numEntradas+numSaidas+1);     
    flag=0;
    for(j=0;j<numEntradas;j++) {

      if(flag==0) {
	  fprintf(OutFile, "%i: %6.5f",j+1,centros[i][j]);
	  flag=1;
      }
      else
	fprintf(OutFile, ", %i: %6.5f",j+1,centros[i][j]);
	  
      
    }
    fprintf(OutFile, "\n");
  }

  */

  // linhas ate encontrar target=(numSaidas+numEntradas+1)
  // a partir dai, comeca a copiar tudo que for lido
  // para o arquivo de saida

  flag=0;
  do {

   fgets(leitura,255,InFile);

   //   printf("leitura=%s\n",leitura);

   if(strstr(leitura,"|")!=NULL) {

     strcpy(temp2,leitura);
     strcpy(temp,strtok(temp2,"|"));

     //     printf("temp=%s, tempN=%i, flag=%i, no=%i\n",temp,atoi(temp),flag, numEntradas+numSaidas+1);

     if( (atoi(temp))==(numEntradas+numSaidas+1) ) flag=1;
   }

  } while(flag==0);

  fputs(leitura , OutFile);

  while(!feof(InFile)) {
   fgets(leitura,255,InFile);
   fputs(leitura , OutFile);
  }
			  

  fclose(InFile);
  fclose(OutFile);

}



double **calloc2Ddouble(int m,int n){
  int i;
  double **matrix;

  matrix = (double **)calloc(m, sizeof(double *));
  if (matrix==NULL){ fprintf(stderr, "Error in allocation of memory. Exit.\n"); exit(1);}
  for (i=0;i<m;i++){
    matrix[i] = (double *)calloc(n, sizeof(double));
    if (matrix[i]==NULL){ fprintf(stderr, "Error in allocation of memory. Exit.\n"); exit(1);}
  }
  return(matrix);
}

